/* fichero determin.c */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define   EPS   1.e-12

void main(void) {
    int    i, j, n, vRet, signo=1;
    double **a, det;
    double **crearMatriz(int m, int n);
    int    triang2(int n, double **a, int *signo);
    int    pivot(int n, int k, double **a);

    /* Lectura de datos y creacion dinamica de matrices y vectores */
    printf("Numero de filas y de columnas: ");
    scanf("%d", &n);
    a=crearMatriz(n, n);  
    printf("\nMatriz del sistema:\n");
    for (i=0; i<n; i++)
        for (j=0; j<n; j++) {
            printf("a(%d, %d): ", i+1, j+1);
            scanf("%lf", &a[i][j]);
        }
    /* Triangularizacion de la matriz */
    vRet=triang2(n, a, &signo);
    if (vRet!=1) {
        printf("El determinante es cero o muy pequeo. Agur! \n");
        exit(1);
    }
    /* Calculo del determinante */
    det=1.0;
    for (i=0; i<n; i++)
         det*=a[i][i]; 
    det*=signo;
    printf("\n\nEl determinante de la matriz es %lf\n", det);
}

/* Funcion para hallar el pivot de la columna k */
int  pivot(int n, int k, double **a) {
    int    i, imaximo;
    double maximo=0.0;
    double va(double);
    for (i=k; i<n; i++) {
        if (maximo<va(a[i][k])) {
            maximo=va(a[i][k]);
            imaximo=i;
        }
    }
    return imaximo;
}

/* Funcion para realizar la triangularizacion de una matriz */
int triang2(int nec, double **a, int *signo) {
    int i, j, k, ipivot, error;
    double fac, *temp;
    double va(double);
    for (k=0; k<nec-1; k++) {
        ipivot=pivot(nec, k, a);
        /* intercambio de los punteros a las filas k e imaximo */
        if (ipivot!=k) {
            temp=a[k];
            a[k]=a[ipivot];
            a[ipivot]=temp;
            *signo=-*signo;
        }
        for (i=k+1; i<nec; i++) {
            if (va(a[k][k])<EPS) 
                return error=-1;
            fac=-a[i][k]/a[k][k];
            for (j=k; j<nec; j++)
                a[i][j]+=a[k][j]*fac;
        }
     }
     return error=1;
}

double **crearMatriz(int m, int n) {
    double **matriz, *mat;
    int i;
    matriz=malloc(m*sizeof(double *));
    matriz[0]=mat=malloc(m*n*sizeof(double));
    for (i=1; i<m; i++)
        matriz[i]=mat+n*i;
    return matriz;
}

double va(double u) {
    if (u<0.0)
        return -u;
    else
        return u;
}
