/* fichero trasp.c */
/* Trasponer una matriz con reserva dinmica de memoria */
#include <stdio.h>
#include <stdlib.h>

void main(void) {
    double **a, **b;
    int  m, n, i, j;
    void *crearMatriz(int m, int n);
    void trasponer(int m, int n, double **a, double **b);
   
    printf("Teclea los numeros de filas y de columnas: ");
    scanf("%d%d", &m, &n);
    a=crearMatriz(m, n);
    b=crearMatriz(n, m);
   
    /* Lectura de la matriz */
    for (i=0; i<m; i++)
        for (j=0; j<n; j++) {
            printf("Elemento a(%d, %d): ", i+1, j+1);
            scanf(" %lf", &a[i][j]);
        }
   
    /* Impresin de la matriz original */
    printf("\n\nLa matriz original es: ");
    for (i=0; i<m; i++) {
        printf("\n");
        for (j=0; j<n; j++) 
            printf("%10.4lf", a[i][j]);
    }
   
    /* se traspone la matriz leida */
    trasponer(m, n, a, b);
   
    /* Impresin de la matriz traspuesta */
    printf("\n\nLa matriz traspuesta es: ");
    for (i=0; i<n; i++) {
        printf("\n");
        for (j=0; j<m; j++) 
            printf("%10.4lf", b[i][j]);
    }
    printf("\n");
}

/* funcin crearMatriz() */
void *crearMatriz(int m, int n) {
    double** a;
    int i;
    a=calloc(m, sizeof(double*));
    for (i=0; i<m; i++)
        a[i]=calloc(n, sizeof(double));
    return a;
}

/* funcin trasponer() */
void trasponer(int m, int n, double **a, double **b) {
    int i, j;
    for (i=0; i<m; i++)
        for (j=0; j<n; j++) 
            b[j][i]=a[i][j];
}         
