/* fichero maxvalp.c */
/* clculo del mximo valor propio por itaracin directa */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void main(void) {
    int i, j, nit=0, orden;
    double vpn, vpv;
    double **a, *vectn, *vectv;

    double **maAlloc(int, int);
    double vabs(double);
    void normalizar(double*, int);
    void matvec(double**, double*, double*, int);

    printf ("Introduce el orden de la matriz: ");
    scanf("%d", &orden);
    a=maAlloc(orden, orden);
    vectv=malloc(orden*sizeof(double));
    vectn=malloc(orden*sizeof(double));

    printf("\nIntroduce los datos de la matriz:\n");
    for (i=0; i<orden; i++)
        for (j=0;j<orden;j++) {
            printf("Elemento (%d,%d): ", (i+1), (j+1));
            scanf("%lf", &a[i][j]);
        }
    for (i=0; i<orden; i++)   /* aproximacin inicial */
        vectn[i]=1.0/sqrt(orden);
    vpn=1;
    do {
        vpv=vpn;
        for (j=0; j<orden; j++)
            vectv[j]=vectn[j];
        matvec(a, vectv, vectn, orden);
        vpn=0.0;
        for (j=0; j<orden; j++)
            vpn+=vectn[j]*vectn[j];
        vpn=sqrt(vpn);
        for (j=0; j<orden; j++)
            vectn[j]=vectn[j]/vpn;
        nit++;
    } while (vabs((vpn-vpv)/vpn)>1e-12);

    printf("\nEl vector buscado es el:\n(");
    for (i=0; i<orden; i++)
        printf("%lf ", vectn[i]);
    printf("\b)");
    printf("\nEl valor propio es: %lf", vpn);
    printf("\nNumero de iteraciones: %d\n", nit);
}

double **maAlloc(int filas, int columnas) {
    int i;
    double **a;
    a=malloc(filas*sizeof(double *));
    for (i=0; i<filas; i++)
        a[i]=malloc(columnas*sizeof(double));
    return a;
}

void matvec(double **matriz, double *vector, double *vector2, int orden) {
    int i,j;
    double sum;
    for (i=0; i<orden; i++) {
        sum=0;
        for (j=0; j<orden; j++)
            sum+=matriz[i][j]*vector[j];
        vector2[i]=sum;
    }
}

double vabs(double a) {
    if (a<0.0)
        return (-a);
    else
        return a;
}
